// WBTest.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "WBTest.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_WBTEST, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_WBTEST));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_WBTEST));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_WBTEST);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

void MakeDebugMessage(HWND hWnd, std::wstring & strMsg)
{
	RECT rcWindow, rcClient;
	GetWindowRect(hWnd, &rcWindow);
	GetClientRect(hWnd, &rcClient);

	RECT rcNCCalc = rcWindow;
	SendMessage(hWnd, WM_NCCALCSIZE, FALSE, reinterpret_cast< LPARAM >( &rcNCCalc ));

	POINT pointTempA, pointTempB;
	pointTempA.x = rcClient.left;
	pointTempA.y = rcClient.top;
	pointTempB.x = rcClient.right;
	pointTempB.y = rcClient.bottom;

	ClientToScreen(hWnd, &pointTempA);
	ClientToScreen(hWnd, &pointTempB);

	RECT rcScreen;
	rcScreen.left   = pointTempA.x;
	rcScreen.top    = pointTempA.y;
	rcScreen.right  = pointTempB.x;
	rcScreen.bottom = pointTempB.y;

	int cxFixedFrame   = GetSystemMetrics(SM_CXFIXEDFRAME);
	int cxSizeFrame    = GetSystemMetrics(SM_CXSIZEFRAME);
	int cxPaddedBorder = GetSystemMetrics(SM_CXPADDEDBORDER);

	RECT rcDwmExtended = {0};
	if (DwmGetWindowAttribute(hWnd, DWMWA_EXTENDED_FRAME_BOUNDS, &rcDwmExtended, sizeof(rcDwmExtended)) != S_OK)
	{
		::SetRectEmpty(&rcDwmExtended);
	}

	DWORD dwStyle = GetWindowLong(hWnd, GWL_STYLE);

	wchar_t szMsg[2048];
	swprintf_s(szMsg,
		L"Current window type:\t\t\t%s\t(Right-click to toggle.)\r\n\r\n"
		L"(DWM Extended Rect):\t\t\t (w=%04d h=%04d) (l=%04d r=%04d t=%04d b=%04d)\r\n\r\n"
		L"GetWindowRect:\t\t\t\t (w=%04d h=%04d) (l=%04d r=%04d t=%04d b=%04d)\r\n"
		L"GetClientRect:\t\t\t\t (w=%04d h=%04d) (l=%04d r=%04d t=%04d b=%04d)\r\n\r\n"
		L"WM_NCCALCSIZE(GetWindowRect):\t (w=%04d h=%04d) (l=%04d r=%04d t=%04d b=%04d)\r\n"
		L"ClientToScreen(GetClientRect):\t\t (w=%04d h=%04d) (l=%04d r=%04d t=%04d b=%04d)\r\n\r\n"
		L"CX Fixed Frame:\t\t %04d\r\n"
		L"CX Size Frame:\t\t %04d\r\n"
		L"CX Padded Border:\t %04d\r\n\r\n"
		L"%s\r\n\r\n"
		L"%s\r\n\r\n"
		L"%s",
		(dwStyle&WS_THICKFRAME) ? L"Resizable." : L"Fixed-size.",
		rcDwmExtended.right-rcDwmExtended.left, rcDwmExtended.bottom-rcDwmExtended.top, rcDwmExtended.left, rcDwmExtended.right, rcDwmExtended.top, rcDwmExtended.bottom,
		rcWindow.right-rcWindow.left, rcWindow.bottom-rcWindow.top, rcWindow.left, rcWindow.right, rcWindow.top, rcWindow.bottom,
		rcClient.right-rcClient.left, rcClient.bottom-rcClient.top, rcClient.left, rcClient.right, rcClient.top, rcClient.bottom,
		rcNCCalc.right-rcNCCalc.left, rcNCCalc.bottom-rcNCCalc.top, rcNCCalc.left, rcNCCalc.right, rcNCCalc.top, rcNCCalc.bottom,
		rcScreen.right-rcScreen.left, rcScreen.bottom-rcScreen.top, rcScreen.left, rcScreen.right, rcScreen.top, rcScreen.bottom,
		cxFixedFrame,
		cxSizeFrame,
		cxPaddedBorder,
		EqualRect(&rcNCCalc,&rcScreen)
			?	L"Good -- WM_NCCALCSIZE and ClientToScreen are consistent."
			:	L"*Bad* -- WM_NCCALCSIZE and ClientToScreen are NOT consistent."
		,
		(dwStyle&WS_THICKFRAME)
			?	((rcNCCalc.left-rcWindow.left)==cxSizeFrame)?L"Good -- WM_NCCALCSIZE(GetWindowRect) differs from GetWindowRect by SM_CXSIZEFRAME.":L"*Bad* -- WM_NCCALCSIZE(GetWindowRect) does NOT differ from GetWindowRect by SM_CXSIZEFRAME."
			:	((rcNCCalc.left-rcWindow.left)==cxFixedFrame)?L"Good -- WM_NCCALCSIZE(GetWindowRect) differs from GetWindowRect by SM_CXFIXEDFRAME.":L"*Bad* -- WM_NCCALCSIZE(GetWindowRect) does NOT differ from GetWindowRect by SM_CXFIXEDFRAME."			
		,
		(dwStyle&WS_THICKFRAME)
			?	((rcScreen.left-rcWindow.left)==cxSizeFrame)?L"Good -- ClientToScreen(GetClientRect) differs from GetWindowRect by SM_CXSIZEFRAME.":L"*Bad* -- ClientToScreen(GetClientRect) does NOT differ from GetWindowRect by SM_CXSIZEFRAME."
			:	((rcScreen.left-rcWindow.left)==cxFixedFrame)?L"Good -- ClientToScreen(GetClientRect) differs from GetWindowRect by SM_CXFIXEDFRAME.":L"*Bad* -- ClientToScreen(GetClientRect) does NOT differ from GetWindowRect by SM_CXFIXEDFRAME."
		);
	strMsg = szMsg;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_MOVE:
	case WM_THEMECHANGED:
		InvalidateRect(hWnd, NULL, FALSE);
		break;
	case WM_RBUTTONDOWN:
		{
			DWORD dwStyle = GetWindowLong(hWnd, GWL_STYLE);
			if (dwStyle&WS_THICKFRAME)
			{
				dwStyle &= ~WS_THICKFRAME;
			}
			else
			{
				dwStyle |= WS_THICKFRAME;
			} 
			SetWindowLong(hWnd, GWL_STYLE, dwStyle);
			SetWindowPos(hWnd, NULL, 0, 0, 0, 0, SWP_FRAMECHANGED|SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOSIZE|SWP_NOZORDER|SWP_NOOWNERZORDER);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		if (hdc)
		{
			RECT rcClient;
			GetClientRect(hWnd, &rcClient);

			rcClient.top += 1;
			rcClient.bottom -= 1;
			rcClient.left += 1;
			rcClient.right -= 1;

			FillRect(hdc, &rcClient, reinterpret_cast<HBRUSH>(GetStockObject(WHITE_BRUSH)));
			FrameRect(hdc, &rcClient, reinterpret_cast<HBRUSH>(GetStockObject(DKGRAY_BRUSH)));

			if (rcClient.top < rcClient.bottom && rcClient.left < rcClient.right)
			{
				rcClient.top += 5;
				rcClient.bottom -= 5;
				rcClient.left += 5;
				rcClient.right -= 5;

				if (rcClient.top < rcClient.bottom && rcClient.left < rcClient.right)
				{
					std::wstring strMsg;

					MakeDebugMessage(hWnd, strMsg);

					DrawText(hdc, strMsg.c_str(), -1, &rcClient, DT_EXPANDTABS);
				}
			}

			EndPaint(hWnd, &ps);
		}
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
